Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 653650 - dev-db/tora-3.2 with Qt 5.11: error: invalid use of incomplete type ‘class QButtonGroup’
Summary: dev-db/tora-3.2 with Qt 5.11: error: invalid use of incomplete type ‘class QB...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Sergey S. Starikoff
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: qt-5.11
  Show dependency tree
 
Reported: 2018-04-21 03:16 UTC by Andreas Sturmlechner
Modified: 2018-07-04 18:21 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log.gz (build.log.gz,27.51 KB, application/gzip)
2018-04-21 03:17 UTC, Andreas Sturmlechner
Details
build.log.gz (build.log.gz,33.66 KB, application/gzip)
2018-05-31 18:54 UTC, Andreas Sturmlechner
Details
tohelp.patch (tohelp.patch,397 bytes, patch)
2018-06-10 15:11 UTC, Sergey S. Starikoff
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Andreas Sturmlechner gentoo-dev 2018-04-21 03:16:37 UTC
Missing header 'QButtonGroup' in at least src/tools/tobrowser.cpp
Comment 1 Andreas Sturmlechner gentoo-dev 2018-04-21 03:17:45 UTC
Created attachment 528112 [details]
build.log.gz
Comment 2 Sergey S. Starikoff 2018-04-26 12:39:20 UTC
Could you confirm this issue is present with tora-9999?
Comment 3 Andreas Sturmlechner gentoo-dev 2018-04-26 17:16:51 UTC
Yes, same error.
Comment 4 Sergey S. Starikoff 2018-05-31 06:09:02 UTC
(In reply to Andreas Sturmlechner from comment #3)
> Yes, same error.

Upstream reports issue is fixed.

Could you verify it with -9999?
Comment 5 Andreas Sturmlechner gentoo-dev 2018-05-31 18:54:28 UTC
Created attachment 534324 [details]
build.log.gz

Unfortunately not, though it is a different header now.
Comment 6 Sergey S. Starikoff 2018-06-10 15:11:53 UTC
Created attachment 535556 [details, diff]
tohelp.patch

https://doc.qt.io/qt-5/qaction.html

Could you try -9999 build with attached patch?

And, probably we need to return epatch_user function call in ebuild's function redefinitions.
Comment 7 Andreas Sturmlechner gentoo-dev 2018-06-14 19:48:40 UTC
(In reply to Sergey S. Starikoff from comment #6)
> Could you try -9999 build with attached patch?
Unforunately no.

src/tools/tobrowser.cpp:492:55: error: invalid use of incomplete type ‘class QButtonGroup’

To fix this properly you'll have to upgrade to >=Qt-5.11.0_beta3...

> And, probably we need to return epatch_user function call in ebuild's
> function redefinitions.
Not necessary with EAPI-6.
Comment 8 Sergey S. Starikoff 2018-06-24 17:48:42 UTC
(In reply to Andreas Sturmlechner from comment #7)
> (In reply to Sergey S. Starikoff from comment #6)
> > Could you try -9999 build with attached patch?
> Unforunately no.
> 
> src/tools/tobrowser.cpp:492:55: error: invalid use of incomplete type ‘class
> QButtonGroup’
> 
> To fix this properly you'll have to upgrade to >=Qt-5.11.0_beta3...
> 

I use stable branch and not sure my test configuration is resposible.

Is it enough to use 5.11.0_rc2-r1 from gentoo overlay or I should use for tests 5.11.9999 from qt overlay?

Your last error seems to be fixed. For now with Qt 5.11.0_rc2-r1 TOra builds (tohelp.patch not included yet).

P.S. Although +pch build seems to be broken, I'll check it later.
Comment 9 Andreas Sturmlechner gentoo-dev 2018-06-26 12:48:42 UTC
(In reply to Sergey S. Starikoff from comment #8)
> Your last error seems to be fixed. For now with Qt 5.11.0_rc2-r1 TOra builds
> (tohelp.patch not included yet).
Thanks, indeed this builds now. Can you prepare a revbump with a patch that contains all the necessary header fixes?
Comment 10 Sergey S. Starikoff 2018-06-27 13:21:01 UTC
(In reply to Andreas Sturmlechner from comment #9)
> Thanks, indeed this builds now. Can you prepare a revbump with a patch that
> contains all the necessary header fixes?

I've asked upstream to include missed patch in master tree.

Possibly stupid question about back compatibility: will Qt-5.11 patched version stay buildable with Qt-5.9 or not?

P.S. Please, review patch from bug #645242
Comment 11 Andreas Sturmlechner gentoo-dev 2018-06-27 13:37:39 UTC
Yes, the additional headers are harmless for backwards compatibility. It only worked pre-Qt-5.11 because they were included implicitly through the other Qt headers in use.
Comment 12 Sergey S. Starikoff 2018-06-29 12:44:42 UTC
(In reply to Andreas Sturmlechner from comment #11)
> Yes, the additional headers are harmless for backwards compatibility. It
> only worked pre-Qt-5.11 because they were included implicitly through the
> other Qt headers in use.

Patch was included in master.

If so… TOra-3.2 was stabilized last year.
I find right to make not revision, but version bump with recent sources snapshot.

I'm not enough familiar with naming conventions in case, when upstream doesn't care about release plan and recommends to use recent git.
Maybe it should like tora-3.2_YYYYMMDD?

Prior to adding it into tree please apply patch from bug #645242 and verify tora-missing-header.patch is unnecessary for recent git.
Comment 13 Andreas Sturmlechner gentoo-dev 2018-07-01 00:19:34 UTC
(In reply to Sergey S. Starikoff from comment #12)
> If so… TOra-3.2 was stabilized last year.
tora has no stable keywords in Gentoo right now.

(In reply to Sergey S. Starikoff from comment #12)
> I find right to make not revision, but version bump with recent sources
> snapshot.
> 
> I'm not enough familiar with naming conventions in case, when upstream
> doesn't care about release plan and recommends to use recent git.
Snapshots are only last resort. Is there evidence of the latter?
Comment 14 Andreas Sturmlechner gentoo-dev 2018-07-01 09:34:18 UTC
(In reply to Sergey S. Starikoff from comment #12)
> I'm not enough familiar with naming conventions in case, when upstream
> doesn't care about release plan and recommends to use recent git.
> Maybe it should like tora-3.2_YYYYMMDD?
See also: https://devmanual.gentoo.org/ebuild-writing/file-format/
Comment 15 Sergey S. Starikoff 2018-07-02 14:11:11 UTC
(In reply to Andreas Sturmlechner from comment #13)
> (In reply to Sergey S. Starikoff from comment #12)
> > If so… TOra-3.2 was stabilized last year.
> tora has no stable keywords in Gentoo right now.

Really.
I'va planned to stabilize -r1 but got no response from proxy-maint.

Requested update fit not only -3.2 but -9999 as well.

Could you fix #645242 ?

> (In reply to Sergey S. Starikoff from comment #12)
> Snapshots are only last resort. Is there evidence of the latter?

I remember, that snapshots are the last resort.

But extrancting necessary patches to make 3.2 release buildable with Qt 5.11 with all needed tests looks to be the worst idea.

We've already done so, when tora-2.3 became completely unbuildable and upstream rejects all bugs recommending to use not released yet and even not beta tora-3.0.
Comment 16 Andreas Sturmlechner gentoo-dev 2018-07-02 14:16:42 UTC
(In reply to Sergey S. Starikoff from comment #15)
> But extrancting necessary patches to make 3.2 release buildable with Qt 5.11
> with all needed tests looks to be the worst idea.
Adding the missing headers is a trivial exercise and certainly does not concern tests, unless in addition to that upstream had to make bigger changes to the code?

I can take care of bug 645242 but not without a fix for Qt-5.11 so we can make progress there.
Comment 17 Larry the Git Cow gentoo-dev 2018-07-02 15:56:56 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f9314b954262a261c8a02301101e160c66ff0c5b

commit f9314b954262a261c8a02301101e160c66ff0c5b
Author:     Andreas Sturmlechner <asturm@gentoo.org>
AuthorDate: 2018-07-02 15:37:39 +0000
Commit:     Andreas Sturmlechner <asturm@gentoo.org>
CommitDate: 2018-07-02 15:56:41 +0000

    dev-db/tora: Fix build with Qt 5.11 (missing headers)
    
    Closes: https://bugs.gentoo.org/653650
    Package-Manager: Portage-2.3.41, Repoman-2.3.9

 dev-db/tora/files/tora-3.2-qt-5.11.0.patch | 69 ++++++++++++++++++++++++++++++
 dev-db/tora/tora-3.2-r1.ebuild             |  5 ++-
 2 files changed, 73 insertions(+), 1 deletion(-)
Comment 18 Sergey S. Starikoff 2018-07-04 14:31:36 UTC
(In reply to Andreas Sturmlechner from comment #16)
> Adding the missing headers is a trivial exercise and certainly does not
> concern tests, unless in addition to that upstream had to make bigger
> changes to the code?
> 
> I can take care of bug 645242 but not without a fix for Qt-5.11 so we can
> make progress there.

Thank you for fix!

Last Qt 5.11 compatibility fix is more than 100 commits later 3.2 release and I don't like idea to review all of then to gather needed fixes.
I plan to ask upstream about marking Qt-5.11 compatible release (for example 3.1.1).

When you plan to turn off mask on Qt-5.11?
Comment 19 Andreas Sturmlechner gentoo-dev 2018-07-04 18:21:19 UTC
(In reply to Sergey S. Starikoff from comment #18)
> Last Qt 5.11 compatibility fix is more than 100 commits later 3.2 release
> and I don't like idea to review all of then to gather needed fixes.
That is unnecessary since the Qt-5.11 fixes work isolated/independently from other commits.

> When you plan to turn off mask on Qt-5.11?
It was done already. tora builds fine as I produced the patch myself.